using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace iTunesListOut.Output
{
    /// <summary>
    /// HTMLŏo͂NX
    /// </summary>
    public class HTMLBuilder : Builder
    {
        private string mFileName;
        private StringBuilder mSb=null;

        public HTMLBuilder(string fileName)
        {
            mFileName = fileName;
            mSb = new StringBuilder();
            mSb.Append("<html lang=\"ja-JP\">\n");
            mSb.Append("<head>\n");
            mSb.Append("<title>iTuneso</title>\n");
            mSb.Append("</head>\n");
            mSb.Append("<body>\n");
        }

        public override void MakeHeader(string[] header)
        {
            mSb.Append("\t<table>\n");
            mSb.Append("\t\t<tr>\n");
            mSb.Append(String.Format("\t\t\t<th>{0}</th>\n", header[0]));
            mSb.Append(String.Format("\t\t\t<th>{0}</th>\n", header[1]));
            mSb.Append(String.Format("\t\t\t<th>{0}</th>\n", header[2]));
            mSb.Append(String.Format("\t\t\t<th>{0}</th>\n", header[3]));
            mSb.Append(String.Format("\t\t\t<th>{0}</th>\n", header[4]));
            mSb.Append("\t\t</tr>\n");

               
        }

        public override void MakeRow(string[] rowData)
        {
            mSb.Append("\t\t<tr>\n");
            mSb.Append(String.Format("\t\t\t<td>{0}</td>\n", rowData[0]));
            mSb.Append(String.Format("\t\t\t<td>{0}</td>\n", rowData[1]));
            mSb.Append(String.Format("\t\t\t<td>{0}</td>\n", rowData[2]));
            mSb.Append(String.Format("\t\t\t<td>{0}</td>\n", rowData[3]));
            mSb.Append(String.Format("\t\t\t<td>{0}</td>\n", rowData[4]));
            mSb.Append("\t\t</tr>\n");
        }

        public override void MakeTitle(string title)
        {
            mSb.Append(String.Format("<h1>{0}</h1>\n",title));
        }

        public override string GetResult()
        {
            using (StreamWriter sw = new StreamWriter(mFileName))
            {
                sw.Write(mSb.ToString());
            }

            return mFileName;
        }

        public override void MakeFooter()
        {
            mSb.Append("\t</table>\n");
            mSb.Append("</body>\n");
            mSb.Append("</html>\n");
        }
    }
}
